import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *

import time

reportPath = r"C:\\Path\\to\\report.pdf"    # TODO - to be changed by user

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version") # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views and CSV logging from preferences
    session.ixload.preferences.enableL23RestStatViews = True
    session.ixload.preferences.enableRestStatViewsCsvLogging = True
    session.ixload.preferences.saveDataModelSnapshot = True

    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()

    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    clientPortList.appendItem(chassisId=1, cardId=7, portId=2).enableCapture = True # TODO - to be changed by user
    serverPortList.appendItem(chassisId=1, cardId=7, portId=6).enableCapture = True # TODO - to be changed by user

    ftpClientActivity = clientCommunity.activityList.appendItemIxActivityFTPClient()
    ftpServerActivity = serverCommunity.activityList.appendItemIxActivityFTPServer()

    getCommand = ftpClientActivity.agent.actionList.appendItemIxGetCommand()
    getCommand.destination = "Traffic2_FTPServer1:21"

    ftpClientActivity.name = 'FTP_Client'
    ftpClientActivity.userIpMapping = '1:1'
    ftpClientActivity.userObjectiveValue = '500'
    ftpClientActivity.secondaryConstraintValue = '800'
    ftpClientActivity.constraintValue = '300'
    ftpClientActivity.enableConstraint = 'False'
    ftpClientActivity.enable = 'True'
    ftpClientActivity.timeline.sustainTime = '60'
    ftpClientActivity.timeline.rampUpValue = '10'
    ftpClientActivity.timeline.iterations = '2'
    ftpClientActivity.timeline.offlineTime = '0'
    ftpClientActivity.timeline.standbyTime = '0'

    ftpServerActivity.enable = 'True'
    ftpServerActivity.customParameters = ''
    ftpServerActivity.protocol = 'FTP'
    ftpServerActivity.type = 'Server'
    ftpServerActivity.name = 'FTP_Server'
    ftpServerActivity.timeline.standbyTime = '0'
    ftpServerActivity.timeline.name = '<Match Longest>'
    ftpServerActivity.timeline.standbyTime = 0
    ftpServerActivity.timeline.sustainTime = '161'

    test.runTest()

    stats = session.ixload.stats
    statName = StatsNameFTPClient()

    while activeTest.currentState == "Running":
        print("Stat values -> %s" % stats.FTPClient.filterValues(
            stats=[statName.kDataTCPConnectionsEstablished, \
                    statName.kSimulatedUsers, \
                    statName.kThroughputKbps, \
                    statName.kFTPDataBytesSent]))
        time.sleep(2)

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

    # wait for capture to complete
    test.waitForAllCaptureData()

    # generate report
    test.generateRestReport(reportPath)

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()
