import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *
import time

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version") # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    # enable rest stat views from preferences
    session.ixload.preferences.enableL23RestStatViews = True

    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()
    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    clientPortList.appendItem(chassisId=1, cardId=7, portId=2).enableCapture = True # TODO - to be changed by user
    serverPortList.appendItem(chassisId=1, cardId=7, portId=6).enableCapture = True # TODO - to be changed by user

    activeTest.activitiesGroupedByObjective = 'False'
    activeTest.allowMixedObjectiveTypes = 'True'
    activeTest.enableForceOwnership = 'True'
    activeTest.enableForceNetworkUpdateCloud = 'False'
    activeTest.enableFrameSizeDistributionStats = 'False'
    activeTest.enableNetworkDiagnostics = 'True'
    activeTest.enableNetworkDiagnosticsLogging = 'False'
    activeTest.enableResetPorts = 'False'
    activeTest.enableTcpAdvancedStats = 'False'
    activeTest.isFrameSizeDistributionViewSupported = 'False'
    activeTest.resetNetworkDiagnosticsAtStartRun = 'False'
    activeTest.statsRequired = 'False'
    activeTest.networkFailureThreshold = '0'
    activeTest.csvInterval = '4'

    httpClientActivity = clientCommunity.activityList.appendItemIxActivityHTTPClient()
    httpServerActivity = serverCommunity.activityList.appendItemIxActivityHTTPServer()

    getCommand = httpClientActivity.agent.actionList.appendItemIxGetCommand()
    getCommand.destination = "Traffic2_HTTPServer1:80"
    getCommand.pageObject = "/1b.html"
    getCommand.enableDi = 'False'

    httpClientActivity.enableConstraint = 'False'
    httpClientActivity.enable = 'True'
    httpClientActivity.constraintValue = '190'
    httpClientActivity.enableConstraint = 'True'
    httpClientActivity.secondaryConstraintValue = '300'
    httpClientActivity.userObjectiveValue = '1000'
    httpClientActivity.name = 'HTTP_Client'
    httpClientActivity.timeline.sustainTime = '200'

    httpServerActivity.name= 'Server_HTTP'
    httpServerActivity.enable = True
    httpServerActivity.protocol = 'HTTP'
    httpServerActivity.timelineId = '2'

    test.runTest()

    stats = session.ixload.stats
    statName = StatsNameHTTPClient()

    while activeTest.currentState == "Running":
        print("Stat values -> %s" % stats.HTTPClient.filterValues(
            stats=[statName.kTCPConnectionsinESTABLISHEDState, \
                    statName.kHTTPSimulatedUsers, \
                    statName.kThroughputKbps, \
                    statName.kHTTPBytesSent]))
        time.sleep(2)

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

    # wait for capture to complete
    test.waitForAllCaptureData()

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()
