import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxLoadRestPyWrapper import *
import time

try:
    setEnvironment(ip='localhost', apiVersion='v0')  # TODO - to be changed by user
    session = IxSessionWrapper(version="version")  # TODO - to be changed by user
    session.start()

    test = session.ixload.test
    chassisChain = session.ixload.chassischain
    chassisList = chassisChain.chassisList
    chassisList.clear()
    chassis = chassisList.appendItem(name="machine_ip") # TODO - to be changed by user
    chassis.refreshConnection()

    activeTest = session.ixload.test.activeTest
    activeTest.enableForceOwnership = True

    clientCommunity = activeTest.communityList.appendItem()
    serverCommunity = activeTest.communityList.appendItem()

    clientCommunity.performanceAcceleration = 'True'
    clientCommunity.showActualCPUUtilizationMode = 'False'
    clientCommunity.throughputAcceleration = 'False'
    clientCommunity.tcpAccelerationAllowedFlag = 'True'

    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    clientPortList.appendItem(chassisId=1, cardId=4, portId=1).enableCapture = True # TODO - to be changed by user
    serverPortList.appendItem(chassisId=1, cardId=4, portId=5).enableCapture = True # TODO - to be changed by user

    activity1 = clientCommunity.activityList.appendItemIxActivitystatelessPeer()
    activity2 = serverCommunity.activityList.appendItemIxActivitystatelessPeer()

    getCommand = activity1.agent.pm.protocolFlows.appendItemIxGenerateipstreamCommand()
    getCommand.remotePeer = "Traffic2_StatelessPeer2"

    activity1.name = 'StatelessPeer100'
    activity1.secondaryEnableConstraint = 'False'
    activity1.enableConstraint = 'True'
    activity1.userObjectiveValue = '90'
    activity1.secondaryConstraintValue = '200'
    activity1.constraintValue = '200'
    activity1.timeline.sustainTime = '120'
    activity1.timeline.rampUpValue = '20'
    activity1.timeline.iterations = '3'

    # enable rest stat views from preferences
    session.ixload.preferences.enableL23RestStatViews = True

    test.runTest()
    stats = session.ixload.stats
    statName = StatsNameStatelessPeer()

    while activeTest.currentState == "Running":
        print("Stat values -> %s" % stats.StatelessPeer.filterValues(
            stats=[statName.kTotalBytesSent, \
                    statName.kTotalBytesReceived, \
                    statName.kInitiatorPeerCount, \
                    statName.kTCPResetsReceived]))
        time.sleep(2)

    while activeTest.currentState != "Unconfigured":
        time.sleep(2)

    # wait for capture to complete
    test.waitForAllCaptureData()

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    session.closeSession()
