import os, sys; sys.path.insert(0, os.path.dirname(os.path.abspath(os.path.join(__file__, os.pardir))))
from Utils.IxRestPyUtils import *
import time

setEnvironment(ip="localhost", apiVersion="v1")
session = createSession(version="9.00.0.177")

try:
    session.start()

    test = session.ixload.test
    test.loadTest(fullPath="D:/l23.rxf")

    activeTest = test.activeTest
    stats = session.ixload.stats

    chassisChain = session.ixload.chassisChain
    chassisList = chassisChain.chassisList
    for chassis in chassisList:
        chassis.refreshConnection()

    clientCommunity = activeTest.communityList[0]
    serverCommunity = activeTest.communityList[1]
    
    clientPortList = clientCommunity.network.portList
    serverPortList = serverCommunity.network.portList

    enableAnalyzerOnPorts(clientPortList)
    enableAnalyzerOnPorts(serverPortList)

    test.runTest()

    while activeTest.currentState == "Running":
        print("Stats values dict -> %s" % (stats.HttpClient.values))
        time.sleep(2)

    test.waitForAllCaptureData()
    
    # retrieveCaptureFileForPort(session, communityPortIdTuple=(0, '1.3.11'), captureFile="D:/captureFolder/Cap_1.3.11.cap")
    retrieveCaptureFileForAssignedPorts(session, captureFolder="D:/captureFolder")

except Exception as ex:
    print("Caught exception -> %s" % (str(ex)))
finally:
    closeSession(session)